<template>
  <v-container>
    <v-layout
      row
      justify-center>
      <v-dialog
        v-model="progressLoading"
        persistent
        fullscreen
        content-class="loading-dialog">
        <v-container fill-height>
          <v-layout
            row
            justify-center
            align-center>
            <v-progress-circular
              :size="70"
              :width="7"
              indeterminate
              color="success"></v-progress-circular>
          </v-layout>
        </v-container>
      </v-dialog>
    </v-layout>
    <v-dialog
      v-model="dialog2"
      max-width="290"
    >
      <v-card
        color="success"
        dark
      >
        <v-card-text class="title font-weight-medium text-xs-center">
          UPLOAD SUCCESSFULLY
        </v-card-text>

        <v-card-actions>
          <v-spacer/>

          <v-btn
            color="white"
            flat="flat"
            @click="dialog2 = false"
          >
            CLOSE
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog
      v-model="error"
      max-width="290"
    >
      <v-card
        color="red"
        dark
      >
        <v-card-text class="title font-weight-bold text-xs-center">
          UPLOAD FAILED
        </v-card-text>

        <v-card-actions>
          <v-spacer/>

          <v-btn
            color="white"
            flat="flat"
            @click="error = false; e1=1; progressLoading = false"
          >
            CLOSE
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog
      v-model="fileError"
      max-width="290"
    >
      <v-card
        color="warning"
        dark
      >
        <v-card-text class="title font-weight-bold text-xs-center">
          ONLY file type .xlsx
        </v-card-text>

        <v-card-actions>
          <v-spacer/>

          <v-btn
            color="white"
            flat="flat"
            @click="fileError = false"
          >
            CLOSE
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog
      v-model="dialog1"
      max-width="290"
      persistent
    >
      <v-card>
        <v-card-text class="headline font-weight-bold text-xs-center">
          <v-form @submit.prevent="submitPin()">
            <v-text-field
              v-model="pin"
              :append-icon="show ? 'mdi-eye' : 'mdi-eye-off'"
              :rules="[rules.required, rules.min, rules.validateNumber]"
              :type="show ? 'text' : 'password'"
              name="pin"
              label="PIN"
              hint="Only 6 characters"
              counter="6"
              @click:append="show = !show"
            ></v-text-field>
          </v-form>
          <span
            v-if="pinError"
            class="red--text body-2">Incorrect PIN</span>
        </v-card-text>

        <v-card-actions>
          <v-spacer/>
          <v-btn
            color="success"
            flat="flat"
            @click="submitPin()"
          >
            SUBMIT
          </v-btn>
          <v-btn
            color="error"
            flat="flat"
            @click="dialog1 = false; pinError=null"
          >
            CLOSE
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-layout
      justify-center
      wrap
    >
      <v-flex
        md10
      >
        <v-stepper v-model="e1">
          <v-stepper-header>
            <v-stepper-step
              :complete="e1 > 1"
              step="1">Upload</v-stepper-step>

            <v-divider/>

            <v-stepper-step
              :complete="e1 > 2"
              step="2">Verify</v-stepper-step>
          </v-stepper-header>

          <v-stepper-items>
            <v-stepper-content step="1">
              <div class="uploadBox">
                <input
                  id="file"
                  ref="file"
                  type="file"
                  accept=".xlsx"
                  @change="handleFilesUpload()">
                <p v-if="file === ''">DRAG and DROP or CLICK HERE to browse</p>
                <v-icon
                  v-if="file !== ''"
                  size="150">mdi-file-document-outline</v-icon>
                <div
                  v-if="file !== ''"
                  class = "file-listing"
                >
                  {{ file.name }}
                </div>
              </div>
              <div>
                <v-btn
                  :class="['submit-button', color]"
                  :loading="loading"
                  :disabled="loading"
                  small
                  @click="beforeVerifyFile()">Continue</v-btn>
                <v-btn
                  class="cancel-button v-btn danger"
                  small
                  @click="removeFile()">Cancel</v-btn>
              </div>
            </v-stepper-content>
            <v-stepper-content step="2">
              <v-card
                color="white"
                class="green--text"
              >
                <div
                  v-for="(course, key) in courses"
                  :key="key"
                  class="file-listing">
                  <v-layout
                    row
                    align-center
                  >
                    <v-flex
                      xs12
                      sm8>
                      {{ course }}
                    </v-flex>
                    <v-flex
                      xs12
                      sm4>
                      <v-select
                        v-model="credit[key]"
                        :items="credits"
                        label="credit"
                      ></v-select>
                    </v-flex>
                  </v-layout>
                </div>

              </v-card>

              <v-btn
                class="cancel-button"
                color="#585858"
                small
                @click="backButton()"
              >BACK</v-btn>
              <v-btn
                :class="['submit-button', color]"
                small
                @click="confirmPin()"
              >
                upload
              </v-btn>
            </v-stepper-content>
          </v-stepper-items>
        </v-stepper>
      </v-flex>
    </v-layout>

  </v-container>
</template>

<script>
import { mapState, mapGetters } from 'vuex'
import XLSX from 'xlsx'

export default {
  data () {
    return {
      dialog1: false,
      dialog2: false,
      error: false,
      fileError: false,
      show: false,
      pin: '',
      file: '',
      courses: [],
      students: null,
      credits: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12],
      credit: [],
      e1: 0,
      progressLoading: false,
      loading: false,
      score: '',
      y: 'top',
      x: null,
      mode: '',
      pinError: null,
      timeout: 6000,
      rules: {
        required: value => !!value || 'Required.',
        min: v => v.length >= 6 || '6 characters',
        validateNumber: v => !isNaN(Number(v)) || 'The PIN you entered must be number'
      }
    }
  },
  computed: {
    ...mapGetters('web3', ['contract', 'student', 'instance', 'userProfile', 'transactionCount']),
    ...mapState('app', ['image', 'color'])
  },
  async mounted () {
    await this.$store.dispatch('web3/connectToWeb3')
    await this.$store.dispatch('web3/setContract')
  },
  methods: {
    handleFilesUpload () {
      if (this.$refs.file.files[0].type === 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet') {
        this.file = this.$refs.file.files[0]
      } else {
        this.fileError = true
        this.file = ''
        this.$refs.file.value = ''
      }
    },
    verifyFile () {
      let file = this.file
      const reader = new FileReader()
      reader.onload = (e) => {
        const bstr = reader.result
        const wb = XLSX.read(bstr, { type: 'binary' })
        const wsname = wb.SheetNames[0]
        const ws = wb.Sheets[wsname]
        const data = XLSX.utils.sheet_to_json(ws, { header: 1 })
        this.data = data
        const courseName = data[3][4].split('  ')
        this.courses.push(courseName[1])
        this.credit.push(3)
        this.loading = false
        this.e1 = 2
      }
      reader.readAsBinaryString(file)
    },
    beforeVerifyFile () {
      if (this.file === '') {
        this.e1 = 1
      } else {
        this.loading = true
        setTimeout(() => this.verifyFile(), 300)
      }
    },
    backButton () {
      this.e1 = 1
      this.courses = []
    },
    confirmPin () {
      this.dialog1 = true
      this.pin = ''
    },
    removeFile () {
      this.loading = false
      this.file = ''
      this.$refs.file.value = ''
    },
    submitPin () {
      if (this.pin !== '') {
        this.$store.dispatch('web3/walletLoad', this.pin)
          .then((wallet) => {
            this.dialog1 = false
            this.progressLoading = true
            setTimeout(() => this.submitFiles(), 300)
          })
          .catch((error) => {
            console.log(error)
            this.pinError = error
            this.pin = ''
          })
      }
    },
    submitFiles () {
      let file = this.file
      this._file(file, 0)
    },
    _file (file, indexCredit) {
      /* Boilerplate to set up FileReader */
      const reader = new FileReader()
      reader.onload = async (e) => {
        /* Parse data */
        const bstr = e.target.result
        const wb = XLSX.read(bstr, { type: 'binary' })
        /* Get first worksheet */
        const wsname = wb.SheetNames[0]
        const ws = wb.Sheets[wsname]
        /* Convert array of arrays */
        const data = XLSX.utils.sheet_to_json(ws, { header: 1 })
        /* Update state */
        this.data = data
        let courseCode = null
        const payload = {
          name: '0x0',
          lecturer: this.instance.utils.stringToHex(localStorage.getItem('lecturer')),
          code: '0x0',
          credit: 0,
          academic_year: '0x0'
        }
        let studentPayload
        let enrollPayload

        for (let index = 0; index < data.length; index++) {
          const obj = data[index]
          if (!isNaN(Number(obj[0]))) {
            try {
              studentPayload = {
                code: this.instance.utils.stringToHex(String(obj[1])),
                firstName: this.instance.utils.stringToHex(obj[2].split(' ')[0]),
                lastName: this.instance.utils.stringToHex(obj[2].split(' ')[1])
              }
            } catch (e) {
              this.error = true
              return
            }

            let grade = 0
            if (obj[8] === 'A') {
              grade = 4
            } else if (obj[8] === 'B+') {
              grade = 3.5
            } else if (obj[8] === 'B') {
              grade = 3
            } else if (obj[8] === 'C+') {
              grade = 2.5
            } else if (obj[8] === 'C') {
              grade = 2
            } else if (obj[8] === 'D+') {
              grade = 1.5
            } else if (obj[8] === 'D') {
              grade = 1
            } else if (obj[8] === 'F') {
              grade = 0
            }

            try {
              enrollPayload = {
                stdCode: this.instance.utils.stringToHex(String(obj[1])),
                courseCode: this.instance.utils.stringToHex(String(courseCode)),
                grade: grade * 10000,
                credit: this.credit[indexCredit]
                // nonce: nonce++
              }
            } catch (e) {
              this.error = true
              return
            }

            let studentData
            try {
              studentData = await this.$store.dispatch('web3/pushStudent', studentPayload)
            } catch (e) {
              this.error = true
              return
            }

            // check if student is already enrolled
            const enrolledCourses = studentData[5]
            const enrolled = enrolledCourses.find(obj => {
              const code = this.instance.utils.hexToString(obj)
              return code === courseCode
            })

            // add enrollment if student is not enroll yet
            if (!enrolled) {
              console.log('enrollment not exist')
              try {
                await this.$store.dispatch('web3/enrollment', enrollPayload)
              } catch (e) {
                this.error = true
                return
              }
            } else {
              console.log('enrollment exist')
            }
          } else if (index === 2 || index === 3) {
            if (index === 2) {
              let semeter
              let academicYear
              try {
                semeter = obj[4].split(' ')[1]
                academicYear = obj[4].split(' ')[3]
                payload.academic_year = this.instance.utils.stringToHex(String(semeter + '/' + academicYear))
              } catch (e) {
                this.error = true
                return
              }
            } else if (index === 3) {
              const code = obj[4].split('  ')
              const name = obj[4].split('  ')
              courseCode = code[0]
              payload.code = this.instance.utils.stringToHex(String(code[0]))
              payload.name = this.instance.utils.stringToHex(name[1])
              payload.credit = this.credit[indexCredit]
              // payload.nonce = nonce++

              try {
                await this.$store.dispatch('web3/pushCourse', payload)
              } catch (e) {
                this.error = true
                return
              }
            }
          }

          if (index === data.length - 1) {
            this.file = ''
            this.$refs.file.value = ''
            this.courses = []
            this.credit = []
            this.progressLoading = false
            this.e1 = 1
            this.dialog2 = true
          }
        }
      }
      reader.readAsBinaryString(file)
    }
  }
}
</script>

<style scoped>
  input[type="file"] {
    position: absolute;
    top: -500px;
    color: transparent;
  }
  div.file-listing {
    position: relative;
    font-size: 18px !important;
    color: black !important;
    text-align: center
  }
  .uploadBox {
    position: relative;
    width: 100%;
    border: 5px dashed #00ADCE;
    text-align: center;
    font-size: 2em;
    padding: 10px 10px;
    min-height: 200px;
    outline-offset: -10px;
  }
  .uploadBox input {
    position: absolute;
    cursor: pointer;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    width: 100%;
    height: 100%;
    opacity: 0;
  }
  .uploadBox p {
    font-size: 20px !important;
    color: #00ADCE;
    text-align: center;
    padding: 70px 0;
  }
  .submit-button {
    font-size: 18px;
    font-weight: 500 !important;
  }
  .cancel-button {
    font-size: 18px;
    font-weight: 500 !important;
  }
</style>
